# **CPET-561 Task List**

### Unity

| Task                                                                                                                                                                                                | Est. hrs | Task Ref. ID |
| --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------- | ------------ |
| Find suitable *physical* camera for virtualization.                                                                                                                                                 | 2        | 1.1          |
| Document each of the *physical* camera parameters -- focal length, resolution of output image, color space of output image, maximum frame rate, etc.                                                | 1        | 1.2          |
| Implement *physical* camera attributes in Unity for each of the two virtual cameras.                                                                                                                | 1        | 1.3          |
| Determine most reasonable locations for each of the two cameras.                                                                                                                                    | 4        | 1.4          |
| Document virtual camera position and angle relative to the center of the court and pass off to algorithm team.                                                                                      | 0.5      | 1.5          |
| Create a realistic test function that receives an input *t*, and moves the ball across the court by *f(t) = t * some-x-value*, where *f(t)* should be the entire length of the court when t = 2.    | 2        | 1.6          |
| **Verify test function can receive an input from MATLAB and ball follows motion. Verify images can be captured and saved with the tennis ball in different positions for initial PDR requirement.** | 1        | 1.7          |

### Communication Layer

| Task                                                                                               | Est. hrs | Task Ref. ID |
| -------------------------------------------------------------------------------------------------- | -------- | ------------ |
| Prototype the transfer layer between Unity frame capture and the SoC.                              | 8        | 2.1          |
| Prototype loading image data into the VDMA buffer for FPGA access.                                 | 4        | 2.2          |
| Prototype the REST API between the processor's calculated position data and the web visualization. | 8        | 2.3          |
| **For PDR: Showcase some form of data transfer between Unity and the SoC**                         |          |              |

### FPGA

| Task                                                                                                                                                         | Est. hrs | Task Ref. ID |
| ------------------------------------------------------------------------------------------------------------------------------------------------------------ | -------- | ------------ |
| Feed a saved image into the FPGA using VDMA buffer.                                                                                                          | 4        | 3.1          |
| Create VHDL IP for processing an image from RGB to grayscale.                                                                                                | 4        | 3.2          |
| Create VHDL IP for processing an image by XORing with a second frame.                                                                                        | 4        | 3.3          |
| Record the delta(t) of each of the possible image processing paths:<br/>img -> rgb_to_grayscale -> XOR -> processed img<br/>img -> XOR -> processed img<br/> | 4        | 3.4          |
| **Showcase delta(t) values for each process as part of the initial PDR requirement. Showcase the final centroid pixel (or closest value).**                  |          | 3.5          |
|                                                                                                                                                              |          |              |
|                                                                                                                                                              |          |              |
|                                                                                                                                                              |          |              |

### Algorithm

| Task                                                                                                                                                                                                                               | Est. hrs | Task Ref. ID |
| ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------- | ------------ |
| Create test data that mimics what the FPGA will send out; i.e. X and Y positions across each of the two images, as well as diameter of the ball in pixels. Test data should be manually created with saved images from Unity team. | 2        | 4.1          |
| From the left and right image TEST positional data, determine position of the tennis ball. Use the formulas from Lab2/3 .                                                                                                          | 2        | 4.2          |
| From the left and right image positional data from the FPGA team, determine position of the tennis ball. Use the formulas from Lab2/3, and possibly using Lab4.                                                                    | 2        | 4.3          |
| **For PDR: Showcase the test calculation for generating X and Y positional data from the pixel values. Showcase the real calculation using positional output from the FPGA.**                                                      |          | 4.4          |

### Data Visualization

| Task                                                                                                                                                  | Est. hrs | Task Ref. ID |
| ----------------------------------------------------------------------------------------------------------------------------------------------------- | -------- | ------------ |
| Create test data for five samples -- each with an X, Y, and Z position. This can be done by running a t-value through the Unity team's test function. | 1        | 5.1          |
| Create a simple webserver GUI that takes in arguments for X, Y, and Z position.                                                                       | 4        | 5.2          |
| **For PDR: Showcase a graph of each sample's X,Y, and Z position on a 2.5D plot.**                                                                    |          | 5.3          |
|                                                                                                                                                       |          |              |

### Business

| Task                                                                                                                   | Est. hrs | Task Ref. ID |
| ---------------------------------------------------------------------------------------------------------------------- | -------- | ------------ |
| Create Gantt chart to track critical path and additional slack times.                                                  | 3        | 6.1          |
| Keep track of all hours and send weekly updates to all stakeholders.                                                   | 2        | 6.2          |
| Create a presentation to highlight each of the completion for PDR in each of the work categories.                      | 5        | 6.3          |
| **For PDR: Create a presentation to highlight each of the PDR requirements and how they were met from each category.** |          | 6.4          |
